#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

typedef struct {
  char llave[20];
  char val[40];
  char newline;
} Linea;

int main(int argc, char *argv[]) {
  if (argc!=3) {
    fprintf(stderr, "Uso: %s <arch-dicc> <llave>\n", argv[0]);
    exit(1);
  }
  char *nomArch= argv[1];
  char *llave= argv[2];
  int tamLlave= strlen(llave);
  
  FILE *fileDicc= fopen(nomArch, "r");
  if (fileDicc==NULL) {
    perror(nomArch);
    exit(2);
  }
  fseek(fileDicc, 0, SEEK_END);
  int tamArch= ftell(fileDicc);
  int numDef= tamArch / sizeof(Linea);
  int i= 0, j= numDef-1;
  Linea lin;
  while (i<=j) {
    int k= (i+j+1)/2;
    if (fseek(fileDicc, k*sizeof(Linea), SEEK_SET)!=0) {
      perror(nomArch);
      exit(3);
    }
    if (fread(&lin, sizeof(Linea), 1, fileDicc)!=1) {
      perror(nomArch);
      exit(4);
    }
    int rc= strncmp(llave, lin.llave, tamLlave);
    if (rc==0)
      break;
    else if (rc<0)
      j= k-1;
    else
      i= k+1;
  }
  if (i>j)
    printf("Llave %s no encontrada\n", llave);
  else {
    lin.newline= 0;
    printf("Valor(%s)=%s\n", llave, lin.val);
  }
  return 0;
}
